'use strict';

module.exports = {
  metadata: {
    name: 'oracle.sample.QuoteOfDay',
    properties: {
      name: {
        required: true,
        type: 'string'
      },
    },
    supportedActions: []
  },

  invoke: (context, done) => {
    // Perform context tasks.
    const {usr} = context.properties();
    context.logger().info("Opening quote generator");
    
    var quotes = require("./src/Quotes.json");
    var quote = quotes[Math.floor(Math.random() * quotes.length)];

    var messageModel = context.MessageModel();
    context.logger().info("User name: "+usr);
    var payload = "Hi " + usr + ". Here's a quote for you.";
    var actions = [];

    var textResponse = 
      messageModel.textConversationMessage(payload, actions);
    context.reply(textResponse);
    
    payload = "'" + quote.quote + "'\n\n Quote by: " + quote.origin;
    context.logger().info("Quote found: " + payload);
    textResponse = 
      messageModel.textConversationMessage(payload, actions);
    context.reply(textResponse).transition();
    done();
  }
};